<p align="center"><img src="https://github.com/elastic/enterprise-search-python/blob/master/logo-enterprise-search.png?raw=true" alt="Elastic Enterprise Search Logo"></p>

<p align="center"><a href="https://circleci.com/gh/elastic/enterprise-search-python"><img src="https://circleci.com/gh/elastic/enterprise-search-python.svg" alt="CircleCI build"></a>

> A first-party Python client for [Elastic Enterprise Search](https://www.elastic.co/solutions/enterprise-search).

## Contents

+ [Getting started](#getting-started-)
+ [Usage](#usage)
+ [FAQ](#faq-)
+ [Contribute](#contribute-)
+ [License](#license-)

***

## Getting started 🐣

Supports Python 2.7 and Python 3.3+.

Depends on [futures](https://github.com/PythonCharmers/python-future) and [requests](https://github.com/requests/requests).

Installed with
`pip <http://pypi.python.org/pypi/pip>`:

```bash
$ python -m pip install elastic_enterprise_search
```

You can also download and install the project source:

```bash
$ python setup.py install
```

## Usage

Retrieve your access token and a content source key after creating your content source.

Indexing a document into a custom content source:

```python
  from elastic_enterprise_search import Client
  content_source_key = 'content source key'
  authorization_token = 'authorization token'
  client = Client(authorization_token)
  documents = [
    {
      'id': '1234',
      'url': 'https://github.com/elastic/enterprise-search-python',
      'title': 'Elastic Enterprise Search Official Python Client',
      'body': 'A descriptive body, with document contents and metadata'
    }
  ]

  document_results = client.index_documents(content_source_key, documents, timeout=10, delay=2)
  print(document_results)
```

### Change API endpoint

```python
client = Client(authorization_token, "https://your-server.example.com/api/v1/ent")
```

## FAQ 🔮

### Where do I report issues with the client?

If something is not working as expected, please open an [issue](https://github.com/elastic/enterprise-search-python/issues/new).

## Contribute 🚀

We welcome contributors to the project. Before you begin, a couple notes...

+ Before opening a pull request, please create an issue to [discuss the scope of your proposal](https://github.com/elastic/enterprise-search-python/issues).
+ Please write simple code and concise documentation, when appropriate.

## License 📗

[Apache 2.0](https://github.com/elastic/enterprise-search-python/blob/master/LICENSE) © [Elastic](https://github.com/elastic)

Thank you to all the [contributors](https://github.com/elastic/enterprise-search-python/graphs/contributors)!
